// the panel for the graphics - top of layout

import java.awt.*;

class graphicPanel extends Panel implements Runnable {
	//decs
	Image img;
	Image[] airplane;
	int animindex=0;
	MediaTracker tracker;
	Thread t;
	int status=0;

	/*
		status=0 regular banner
		status=1 glider animation
	*/

	//constructor - not sure why I have parent here...
	graphicPanel(zapsPanel parent, Image img, Image[] airplane, MediaTracker tracker) {
		setSize(390,75);
		setBackground(Color.black);
		this.img=img;
		this.airplane=airplane;
		this.tracker=tracker;
		repaint();
	}

	public void paint(Graphics g) {
		if (status==0) {
			if (tracker.checkID(0, true)) {
				g.drawImage(img, 0, 0, this);
			} else {
				g.drawString("images loading...", 20, 40);
			}
		} else if (status==1) {
			if (tracker.checkID(animindex+1, true)) {
				g.drawImage(airplane[animindex], 0, 0, this);
			} else {
				g.drawString("images loading...", 20, 40);
			}
		}
	}

	// the thread simply counts through the index of airplane
	public void run() {
		while (true) {
			for (animindex=0; animindex<airplane.length; animindex++) {
				repaint();
				try {
					Thread.sleep(200);
				} catch (InterruptedException e) {
					System.out.println("Someone is waking my animation thread up from its sleep: "+ e);
				}
			}
		}
	}

	protected void showBanner() {
		try {
			Thread.sleep(10000);
		} catch (InterruptedException e) {
			System.out.println("Someone is waking my animation thread up from its sleep: "+ e);
		}
		if (t!=null) {
			t.stop();  // deprecated in java 2
			t=null;
		}
		status=0;
		repaint();
	}

	protected void playGlider() {
		t= new Thread(this);
		status=1;
		t.start();
		repaint();
	}

	// override update
	public void update(Graphics g) {
		paint(g);
	}
}
