// frame class for running zaps tribal port scan as an application.
// updated 1/20/2k - fixed problems in the second and third constructors
// related to the animation (number of frames) and layout...

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

class theFrame extends Frame {
	//decs
	zapsPanel zappan;
	Font f;
	Image banner;
	Image[] airplane;
	MediaTracker tracker;
	Toolkit tk;
	String target;
	zapsMessage zapmsg;

	// constructor for application use (with default target...)
	theFrame() {
		// get images
		tracker= new MediaTracker(this);
		tk=Toolkit.getDefaultToolkit();
		banner= tk.getImage("banner.gif");
		airplane= new Image[18];
		int i; // just for counting
		for (i=1; i<airplane.length+1; i++) {
			airplane[i-1]=tk.getImage(i+".gif");
			tracker.addImage(airplane[i-1], i);
		}
		tracker.addImage(banner, i+1);

		target="127.0.0.1"; // localhost is default

		// font
		f=new Font("Dialog",Font.PLAIN, 10);

		// load file and make a zapsMessage ob
		// (or just make a default zapsmessage ob) see its constructors...
		// always tries to load messages.txt in this constructor
		try {
			BufferedReader in = new BufferedReader(new FileReader("messages.txt"));
			// load file contents into a String[] and use it to create zapsMessage ob
			// create a temp Vector of String objects from the file contents
			Vector vec= new Vector();
			String[] temp;

			while (in.ready()) {
				vec.addElement(in.readLine());
			}
			temp= new String[vec.size()];
			for (i=0; i<vec.size(); i++) {
				temp[i]=(String)vec.elementAt(i);
			}
			zapmsg= new zapsMessage(temp);

		} catch(FileNotFoundException e) {
			System.out.println("messages.txt not found, using default implementation " + e);
			zapmsg= new zapsMessage();	// default implementation
		} catch(IOException e) {
			System.out.println("messages.txt not found, using default implementation " + e);
			zapmsg= new zapsMessage();	// default implementation
		}

		zappan = new zapsPanel(f, banner, airplane,
			tracker, target, this, zapmsg, false); // false, not an applet
		add(zappan);
		setSize(new Dimension(410,330)); 	// 330 is a good height on windows, java 2 (1.3)
							// I have noted promblems on other jvm's such as
							// java 1.1.6 for IRIX... write once, revise everywhere
		setTitle("Zapatista Tribal Port Scan");
		show();
		addWindowListener(new ztpsFrameListener());
	}

	// constructor for application with target argument passed
	theFrame(String target) {
		this.target=target;
		// get images
		tracker= new MediaTracker(this);
		tk=Toolkit.getDefaultToolkit();
		banner= tk.getImage("banner.gif");
		airplane= new Image[18];
		int i; // just for counting
		for (i=1; i<airplane.length+1; i++) {
			airplane[i-1]=tk.getImage(i+".gif");
			tracker.addImage(airplane[i-1], i);
		}
		tracker.addImage(banner, i+1);

		// load file and make a zapsMessage ob
		// (or just make a default zapsmessage ob) see its constructors...
		zapsMessage zapmsg= new zapsMessage();	// default

		// later do some dynamic font checking....
		f=new Font("Dialog",Font.PLAIN, 10);

		// load file and make a zapsMessage ob
		// (or just make a default zapsmessage ob) see its constructors...
		// always tries to load messages.txt in this constructor
		try {
			BufferedReader in = new BufferedReader(new FileReader("messages.txt"));
			// load file contents into a String[] and use it to create zapsMessage ob
			// create a temp Vector of String objects from the file contents
			Vector vec= new Vector();
			String[] temp;

			while (in.ready()) {
				vec.addElement(in.readLine());
			}
			temp= new String[vec.size()];
			for (i=0; i<vec.size(); i++) {
				temp[i]=(String)vec.elementAt(i);
			}
			zapmsg= new zapsMessage(temp);

		} catch(FileNotFoundException e) {
			System.out.println("messages.txt not found, using default implementation "+ e);
			zapmsg= new zapsMessage();	// default implementation
		} catch(IOException e) {
			System.out.println("I/O problem with messages.txt, using default implementation "+ e);
			zapmsg= new zapsMessage();	// default implementation
		}

		zappan = new zapsPanel(f, banner, airplane,
			tracker, target, this, zapmsg, false); // false, not an applet
		add(zappan);
		setSize(new Dimension(410,330)); 	// 330 is a good height on windows, java 2 (1.3)
							// I have noted promblems on other jvm's such as
							// java 1.1.6 for IRIX... write once, revise everywhere
		setTitle("Zapatista Port Scan");
		show();
		addWindowListener(new ztpsFrameListener());
	}

	// constructor for application with target argument passed
	theFrame(String target, String messagefile) {
		this.target=target;
		// get images
		tracker= new MediaTracker(this);
		tk=Toolkit.getDefaultToolkit();
		banner= tk.getImage("banner.gif");
		airplane= new Image[18];
		int i; // just for counting
		for (i=1; i<airplane.length+1; i++) {
			airplane[i-1]=tk.getImage(i+".gif");
			tracker.addImage(airplane[i-1], i);
		}
		tracker.addImage(banner, i+1);

		// load file and make a zapsMessage ob
		// (or just make a default zapsmessage ob) see its constructors...
		zapsMessage zapmsg= new zapsMessage();	// default

		// later do some dynamic font checking....
		f=new Font("Dialog",Font.PLAIN, 10);

		// load file and make a zapsMessage ob
		// (or just make a default zapsmessage ob) see its constructors...
		// always tries to load messages.txt in this constructor
		try {
			BufferedReader in = new BufferedReader(new FileReader(messagefile));
			// load file contents into a String[] and use it to create zapsMessage ob
			// create a temp Vector of String objects from the file contents
			Vector vec= new Vector();
			String[] temp;

			while (in.ready()) {
				vec.addElement(in.readLine());
			}
			temp= new String[vec.size()];
			for (i=0; i<vec.size(); i++) {
				temp[i]=(String)vec.elementAt(i);
			}
			zapmsg= new zapsMessage(temp);

		} catch(FileNotFoundException e) {
			System.out.println(messagefile + " not found, using default implementation "+ e);
			zapmsg= new zapsMessage();	// default implementation
		} catch(IOException e) {
			System.out.println("I/O problem with " + messagefile + ", using default implementation "+ e);
			zapmsg= new zapsMessage();	// default implementation
		}

		zappan = new zapsPanel(f, banner, airplane,
			tracker, target, this, zapmsg, false); // false, not an applet
		add(zappan);
		setSize(new Dimension(410,330)); 	// 330 is a good height on windows, java 2 (1.3)
							// I have noted promblems on other jvm's such as
							// java 1.1.6 for IRIX... write once, revise everywhere
		setTitle("Zapatista Port Scan");
		show();
		addWindowListener(new ztpsFrameListener());
	}
}

class ztpsFrameListener extends WindowAdapter {
	public void windowClosing(WindowEvent we) {
		System.exit(0);
	}
}
