/* zapsMessage.java
	this class provides a method, String getString(), to return 
	a random string of text to be written to a port...
	It is used by zapsPanel in calls to new portScan to provide
	the message to send over the tcp connection or UDP packet...
	Many kinds of things can be with this.
	We are using a default poem by rdom where the individual lines are intended 
	to be selected at random.
	If there is a message.txt file in the directory with the html
	then the data from that file will be loaded instead of the rdom poem...
*/

public class zapsMessage {
	//declarations
	private boolean file_implementation; 	// true if passed a String[] (the contents of message.txt file)
						// otherwise false - see constructors
	// this String array is the default poem for ZTPS
	// if implementors provide a file named message.txt
	// its contents will replace these....
	private String[] data = {
		"Zapatista Technology",
		"Maya Time",
		"Air Notes",
		"Armed Words",
		"Paper Force",
		"EZLN 2001",
		"San Andres",
		"peace pact",
		"signed accords",
		"indigenous rights",
		"Paz Digna",
		"Fox promise",
		"La Realidad",
		"distributed encounters",
		"beyond Seattle",
		"las futuras",
		"always already",
		"future hacking",
		"against neoliberalism",
		"continuing repression",
		"taking Land",
		"taking communities",
		"taking rights",
		"Ya Basta!",
		"new dawn",
		"nightmare ends",
		"jungle waits",
		"silence breaks",
		"nuestra arma",
		"nuestra palabra",
		"Yepa! Yepa!",
		"Andale! Andale!",
		"Arriba! Arriba!",
		"Subcomandante Insurgente",
		"Mexican Southeast",
		"November 2000",
		"post presidente",
		"Ernesto Zedillo",
		"assassination administration",
		"enroute nowhere",
		"Acteal 1996",
		"peace justice",
		"bad joke",
		"sisters brothers",
		"conciencia internacional",
		"necesitamos difundir",
		"la palabra",
		"tomar accion",
		"nueva fronteras",
		"Lacandona dark",
		"all power",
		"for D.F",
		"electricity arrives",
		"Chiapas heart",
		"Italian kilowatts",
		"virtual autonomy",
		"real politics",
		"not over",
		"top down",
		"cracks open",
		"reality arcs",
		"No Illegals",
		"Mexico USA",
		"Operation Gatekeeper",
		"Border war",
		"Every hour",
		"Someone dies",
		"amor rabia",
		"suspended particles",
		"adicciones ironicas",
		"mariposa rotas",
		"drift zones",
		"futuras globales",
		"ezln org",
		"utexas edu",
		"ecd html",
		"thing net",
		"rhizome org",
		"rtmark com",
		"nettime org",
		"fakeshop com",
		"etoy com",
		"cadre edu",
		"auto nomedia",
		"network art",
		"tactical media",
		"hack tivismo",
		"indy media",
		"net strikes",
		"La Mar",
		"Old Antonio",
		"Durito Bug",
		"Little Pedrito",
		"Commandante Tacho",
		"Commandante Ramona",
		"Zapatista Technology",
		"Maya Time",
		"Air Notes",
		"Armed Words",
		"Paper Force",
		"EZLN 2001"
	};

	// constructor one - using default poem
	zapsMessage() {
		file_implementation=false;
	}
	
	// constructor 2 - accepts an alternative String array
	zapsMessage(String[] data) {
		this.data=data;
		file_implementation=true;
	}
	
	// 
	public String getString() {
		return data[((int)(Math.random()*data.length))];
	}

	// in case some other ob needs to know...
	public boolean is_custom_file_implementation() {
		return file_implementation;
	}
}
