/* zapsTimer.java
a simple callback timer for the Zapatista Tribal Port Scan
int minutesleft contains the time left until this thread
should signal the the calling object (the zapsPanel) that 
it is time to send the scan... ( zapsPanel.sendScan() )
after which the zapsTimer object dies...

It also decrements zapsTimer every one minute and updates
the zapsPanel which updates it's controlPanel object timer 
label. (by calling zapsPanel.updateTimerLab(int newminutes, zapsPanel the_creator) )

It also has a stopTimer() method so that the zapsPanel can kill 
it safely.

It can also be reset with it's reset(int newminutes) method...

*/

public class zapsTimer implements Runnable {
	Thread t;
	boolean stopflag=false;
	int minutesleft;
	zapsPanel zapspanel;
	
	zapsTimer(int minutesleft, zapsPanel the_creator) {
		zapspanel = the_creator;
		this.minutesleft = minutesleft;
		t=new Thread(this, "zaps timer");
		t.start();
	}

	public void run() {
		while (!stopflag){
			// check for time out, else update display
			if (minutesleft <= 0) {
				zapspanel.sendScan();
				stopflag=true;
				break; // exit while loop - no need to sleep again...
			} else {
				zapspanel.updateTimerLab(minutesleft);
			}
			// sleep
			try {
				Thread.sleep(60000); // sleep one minute
				// decrement timer
				minutesleft--;
			} catch (InterruptedException e) {
				System.out.println("The zapsTimer was Interrupted(Exception)");
			}
		}
	}

	protected void reset(int newminutes) {
		minutesleft=newminutes;
		zapspanel.updateTimerLab(minutesleft);
	}
}
