/*
	ap/applet - Zapatista Tribal Port Scan
	The year 2001 may bring a stop to ethnic cleansing in Chiapas.
	EDT offers all support and encouragement to President Fox to
	participate in the end of the war.
	But we should not forget US government support of ethnic
	cleansing in Mexico! We should not forget the NATO air war in
	Yugoslavia, with its fine intention (and perhaps result) of
	stopping a brutal genocide, while at the same time we saw
	simultaneous U.S. military support for then President Zedillo's
	similar ethnic cleansing in Chiapas. And we should not forget that
	an end to open hostilities almost never marks an end to the problems
	that facilitated them.

*/

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class ztps extends Applet {
	//decs
	zapsPanel zappan;
	messagePanel messagepanel;
	Font f;
	// image loading stuff
	Image banner;
	Image[] airplane;
	MediaTracker tracker;
	// parameter stuff
	String target; // the target site
	String message; // message for message area
	String archive; // location of the download archive
	String default_archive;
	URL downloadURL;
	String message_file; // custom message file for scanner
	BufferedReader in;
	zapsMessage zapmsg;
	AudioClip paper_plane;

	// the init method is only called for applets...
	public void init() {
		// get applet parameters

		// the target site
		target= getParameter("target");
		if ((target==null)||(target.equals(""))){
			target="127.0.0.1"; // if there is no target specified in param, use localhost
		}

		// custom message to display on the panel
		message= getParameter("message");
		if ((message==null)||(message.equals(""))){
			message="ZTPS, Electronic Disturbance Theater, 2K1";
		}

		// make a download url
		default_archive="http://cadre.sjsu.edu/beestal/scanarchive/dir.pl";
		archive= getParameter("download_archive");
		if ((archive==null)||(archive.equals(""))){
			archive=default_archive;
		}
		try {
			downloadURL= new URL(archive);
		} catch (MalformedURLException e) {
			try {
				downloadURL= new URL(default_archive);
				System.out.println("ZTPS: creating default archive url");
			} catch (MalformedURLException e2) {
				System.out.println("ZTPS: can't create download url");
			}
		}

		// any implementer specified message file in the zaps_messages param are read here
		message_file= getParameter("zaps_messages");

		// load file and make a zapsMessage ob
		// (or just make a default zapsmessage ob) see its constructors...
		if ((message_file==null)||(message_file.equals(""))){ // no parameter
			zapmsg= new zapsMessage();	// default implementation
		} else { // load file contents into a String[] and use it to create zapsMessage ob
			// get url of file
			String url_string=getDocumentBase().toString();
        		url_string=url_string.substring(0,url_string.lastIndexOf('/'))+"/"+message_file;
			// create a temp Vector of String objects from the file contents
			Vector vec= new Vector();
			String[] temp;
   			try {
				URL url=new URL(url_string);
				// get an input stream from the file
				in = new BufferedReader(new InputStreamReader(url.openStream()));
				while (in.ready()) {
					vec.addElement(in.readLine());
				}
				temp= new String[vec.size()];
				for (int i=0; i<vec.size(); i++) {
					temp[i]=(String)vec.elementAt(i);
				}
				zapmsg= new zapsMessage(temp);
			}
			catch(MalformedURLException e) {
				System.out.println("bad url for zap_message param: "+zapmsg+" "+ e);
				zapmsg= new zapsMessage();	// default implementation
			}
			catch(IOException e) {
				System.out.println("file input error for zap_message param: "+zapmsg+" "+ e);
				zapmsg= new zapsMessage();	// default implementation
			}
		}

		// end parameter loading biz

		// load sound
		paper_plane=getAudioClip(getCodeBase(),"paper_plane.au");

		// load images
		tracker= new MediaTracker(this);

		// load banner image (banner.gif)
		banner= getImage(getDocumentBase(), "banner.gif");
		tracker.addImage(banner, 0);

		// load airplane animation
		int i; //just for counting
		airplane= new Image[18];
		// adding 1 to the index here for "1" based index
		for (i=1; i<airplane.length+1; i++) {
			airplane[i-1]=getImage(getDocumentBase(), (i)+".gif");
			tracker.addImage(banner, i);
		}

		f=new Font("Dialog",Font.PLAIN, 10);

		zappan = new zapsPanel(f, banner, airplane,
			tracker, target, this, zapmsg, true); // true if applet
		setLayout(new BorderLayout(10,10));
		setBackground(Color.black);
		messagepanel=new messagePanel(zappan, message, downloadURL, getAppletContext());
		add(zappan, "Center");
		add(messagepanel, "South");
		repaint();
	}

	// used to update message panel in applet
	protected void updateMessagePanel(String str) {
		messagepanel.updateLabel(str);
	}

	protected void play_paper_plane_sound() {
		paper_plane.play();
	}

	// main method is called for applications
	// ztps can be used as an application by invoking it from the command line
	// with one or two optional arguments - 1) the target domain, 2) a message file
	// the default domain is localhost (127.0.0.1) and default message file is messages.txt
	public static void main(String args[]) {
		if (args.length < 1) { 		// no args
			new theFrame();
		} else if (args.length == 1){ 	// one arg, the target
			new theFrame(args[0]);
		} else { 			// two args, the target and the message file
			new theFrame(args[0], args[1]);
		}
	}
}

