/* this panel formats the control area, containing the 
output textarea. settings panel, and slider */

import java.awt.*;
import java.awt.event.*;

class controlPanel extends Panel implements AdjustmentListener, ItemListener {
	// decs
	TextArea ta;
	settingsPanel settings;
	Label timing;
	Label timesetting;
	Label timer_lab;
	Label min1;
	Label min60;
	Scrollbar scroll;
	GridBagConstraints gc;
	zapsPanel parent;
	long time=0;
	
	//constructor
	controlPanel (zapsPanel parent) {
		setBackground(new Color(215, 106, 73));
		setLayout(new GridBagLayout());
		gc= new GridBagConstraints();
		gc.insets=new Insets(5,5,5,5);
		settings = new settingsPanel(this, parent);
		ta= new TextArea("scan log:\n",5,40, TextArea.SCROLLBARS_BOTH);
		ta.setBackground(Color.white);
		ta.setFont(parent.thefont);
		scroll= new Scrollbar(Scrollbar.HORIZONTAL, 0, 1, 0, 60);
		scroll.setBackground(Color.white);
		timesetting= new Label("1");
		timesetting.setFont(parent.thefont);
		timesetting.setAlignment(Label.RIGHT);
		timing= new Label("<--- Scan Interval  &&  Timer --->");
		timing.setFont(parent.thefont);
		timing.setAlignment(Label.CENTER);
		timer_lab= new Label("1");
		timer_lab.setFont(parent.thefont);
		timer_lab.setAlignment(Label.LEFT);
		min1=new Label("1 min");
		min1.setFont(parent.thefont);
		min1.setAlignment(Label.RIGHT);
		min60=new Label("60 min");
		min60.setFont(parent.thefont);
		min60.setAlignment(Label.LEFT);

		// textarea
		parent.setConstraints(gc,0,0,2,1,80,99);
		gc.anchor=GridBagConstraints.CENTER;
		gc.fill=GridBagConstraints.BOTH;
		add(ta,gc);
		// settings panel
		parent.setConstraints(gc,2,0,1,1,15,99);
		gc.anchor=GridBagConstraints.CENTER;
		gc.fill=GridBagConstraints.BOTH;
		add(settings,gc);

		// timing label
		parent.setConstraints(gc,0,1,1,1,5,1);
		gc.anchor=GridBagConstraints.EAST;
		gc.fill=GridBagConstraints.HORIZONTAL;
		add(timesetting,gc);
		// time setting contol label <-- * --> 
		parent.setConstraints(gc,1,1,1,1,75,1);
		gc.anchor=GridBagConstraints.CENTER;
		gc.fill=GridBagConstraints.HORIZONTAL;
		add(timing,gc);
		// timer setting label
		parent.setConstraints(gc,2,1,1,1,15,1);
		gc.anchor=GridBagConstraints.WEST;
		gc.fill=GridBagConstraints.HORIZONTAL;
		add(timer_lab,gc);

		// 1min
		parent.setConstraints(gc,0,2,1,1,5,1);
		gc.anchor=GridBagConstraints.EAST;
		gc.fill=GridBagConstraints.NONE;
		add(min1,gc);				
		// scrollbar
		parent.setConstraints(gc,1,2,1,1,75,1);
		gc.anchor=GridBagConstraints.WEST;
		gc.fill=GridBagConstraints.HORIZONTAL;
		add(scroll,gc);
		// 60min
		parent.setConstraints(gc,2,2,1,1,15,1);
		gc.anchor=GridBagConstraints.WEST;
		gc.fill=GridBagConstraints.NONE;
		add(min60,gc);
		scroll.addAdjustmentListener(this);
		this.parent=parent;
	}
	
	public void adjustmentValueChanged(AdjustmentEvent e) {
		timesetting.setText(Integer.toString(getMinutes()));
		// tell the parent what the new average time is
		// should be a method in zapPanel...
		parent.timer.reset(getMinutes());
	}

	
	public void itemStateChanged(ItemEvent e) {
		if (e.paramString().indexOf("TCP") != -1){
			parent.userSelected(portScan.TCP);
		} else if (e.paramString().indexOf("UDP")!= -1) {
			parent.userSelected(portScan.UDP);
		} else {
			parent.userSelected(parent.ZAP);
		}
	}
	
	// returns the minutes directly from the scrollbar
	public int getMinutes() {
		return scroll.getValue()+1;
	}
}
